package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.Expend;
import com.ff.weijinxiao.repository.ExpendRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class ExpendService {

    @Resource
    private ExpendRepository expendRepository;

    /**
     * 创建实体
     *
     * @param expend
     */
    public Expend saveExpend(Expend expend) {
        return expendRepository.save(expend);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public Expend findById(Integer id) {
        Optional<Expend> optional = expendRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        expendRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<Expend> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return expendRepository.findAll(SpecificationUtil.buildSpecification(param, Expend.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<Expend> findList(Map<String, Object> param) {
        return expendRepository.findAll(SpecificationUtil.buildSpecification(param, Expend.class));
    }

}
